Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/antmod/FeedbackListener.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/antmod/FeedbackListener.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/antmod/FeedbackListener.java	(revision 15210)
@@ -35,5 +35,5 @@
 
 	private final SwingInstallerContext swingCtx;
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	public FeedbackListener(SwingInstallerContext swingCtx) {
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/AppRootInput.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/AppRootInput.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/AppRootInput.java	(revision 15210)
@@ -36,5 +36,5 @@
 	extends DirectoryInput {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/DirectoryInput.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/DirectoryInput.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/DirectoryInput.java	(revision 15210)
@@ -34,5 +34,5 @@
 	extends OSSpecific {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/page/Page.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/page/Page.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/page/Page.java	(revision 15210)
@@ -46,7 +46,8 @@
 //	 i18n support
 	private static ResourceBundle langPack = null;
+	//private static ResourceBundle otherLangPack = null;
 	static{
 		try {
-			langPack = ResourceBundle.getBundle("LanguagePack");
+			langPack = ResourceBundle.getBundle("resources.LanguagePack");
 		} catch (MissingResourceException e) {
 			// ignore, signifies no lang packs installed  
@@ -78,8 +79,8 @@
 
 	public String getDisplayText() {
-		if(langPack != null){
-			return langPack.getString("page." + getName() + ".displayText");
-		}
-		return displayText;
+		if( langPack != null){
+			return langPack.getString("page." + getName() + ".displayText") + "r";
+		}
+		return displayText + "c";
 	}
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res.properties
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res.properties	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res.properties	(revision 15210)
@@ -1,3 +1,3 @@
-#org.tp23.antinstaller.renderer.Res
+#resources.LanguagePack
 #Wed Nov 10 01:06:42 CET 2004
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_de.properties
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_de.properties	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_de.properties	(revision 15210)
@@ -1,3 +1,3 @@
-#org.tp23.antinstaller.renderer.Res
+#resources.LanguagePack
 #Wed Nov 10 01:06:42 CET 2004
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_es.properties
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_es.properties	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_es.properties	(revision 15210)
@@ -1,3 +1,3 @@
-#org.tp23.antinstaller.renderer.Res
+#resources.LanguagePack
 #Wed Nov 10 01:06:42 CET 2004
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_es_EU.properties
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_es_EU.properties	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/Res_es_EU.properties	(revision 15210)
@@ -1,3 +1,3 @@
-#org.tp23.antinstaller.renderer.Res
+#resources.LanguagePack
 #Wed Nov 10 01:06:42 CET 2004
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ConditionalFieldRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ConditionalFieldRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ConditionalFieldRenderer.java	(revision 15210)
@@ -36,5 +36,5 @@
 public class ConditionalFieldRenderer extends SwingOutputFieldRenderer {
     
-    private ResourceBundleHelper resHelper = new ResourceBundleHelper( "org.tp23.antinstaller.renderer.Res" );
+    private ResourceBundleHelper resHelper = new ResourceBundleHelper( "resources.LanguagePack" );
     private ConditionalField condField;
     private ArrayList renderers = new ArrayList( );
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ConfirmPasswordTextInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ConfirmPasswordTextInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ConfirmPasswordTextInputRenderer.java	(revision 15210)
@@ -20,5 +20,5 @@
 public class ConfirmPasswordTextInputRenderer extends PasswordTextInputRenderer{
 	
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 	
 	protected String getErrorMessage(){
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/DateInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/DateInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/DateInputRenderer.java	(revision 15210)
@@ -33,5 +33,5 @@
 	extends SwingOutputFieldRenderer {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 	
 	protected DateInput inputField;
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/DirectoryInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/DirectoryInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/DirectoryInputRenderer.java	(revision 15210)
@@ -37,5 +37,5 @@
 	extends SwingOutputFieldRenderer {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
     private static final String EMPTY_STRING = "";
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/FileInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/FileInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/FileInputRenderer.java	(revision 15210)
@@ -37,5 +37,5 @@
 	extends SwingOutputFieldRenderer {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	protected FileInput inputField;
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/LargeSelectInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/LargeSelectInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/LargeSelectInputRenderer.java	(revision 15210)
@@ -31,5 +31,5 @@
 	extends SwingOutputFieldRenderer {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	protected LargeSelectInput inputField;
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/LicensePageRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/LicensePageRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/LicensePageRenderer.java	(revision 15210)
@@ -43,5 +43,5 @@
 	extends SwingPageRenderer {
 
-    private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+    private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	private JTextArea licenseTextArea = new JTextArea();
@@ -59,4 +59,6 @@
 		InputStream licensein = this.getClass().getResourceAsStream(resource);
 		if (licensein == null) {
+			//delete me
+			System.out.println( "licensein is null" );
 			throw new ConfigurationException("License resource '" + resource + "' is missing from installer");
 		}
@@ -79,12 +81,16 @@
 		scrollPane.getViewport().add(licenseTextArea);
 		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
-		scrollPane.setBorder(BorderFactory.createCompoundBorder(
-						BorderFactory.createEmptyBorder(4, 4, 4, 4),
-			            BorderFactory.createEtchedBorder()));
+
+		scrollPane.setBorder(
+			BorderFactory.createCompoundBorder(
+				BorderFactory.createEmptyBorder(4, 4, 4, 4),
+				BorderFactory.createEtchedBorder()
+				)
+			);
 		this.add(scrollPane, BorderLayout.CENTER);
 
-        getNextButton().setText( res.getString( "license.next.text" ) );
-        getNextButton().setIcon(getImage("/resources/icons/ok.png"));
-        getCancelButton().setText( res.getString( "license.cancel.text" ) );
+		getNextButton().setText( res.getString( "license.next.text" ) );
+		getNextButton().setIcon(getImage("/resources/icons/ok.png"));
+		getCancelButton().setText( res.getString( "license.cancel.text" ) );
 
     }
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/PasswordTextInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/PasswordTextInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/PasswordTextInputRenderer.java	(revision 15210)
@@ -28,5 +28,5 @@
 public class PasswordTextInputRenderer extends ValidatedTextInputRenderer{
 	
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 	
     public PasswordTextInputRenderer() {
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ProgressPageRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ProgressPageRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ProgressPageRenderer.java	(revision 15210)
@@ -47,5 +47,5 @@
 	implements AntOutputRenderer {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 	private static final int MESSAGE_PANEL_HEIGHT = 30;
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/SelectInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/SelectInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/SelectInputRenderer.java	(revision 15210)
@@ -33,5 +33,5 @@
 	extends SwingOutputFieldRenderer {
 	
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	protected SelectInput inputField;
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/SwingPageRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/SwingPageRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/SwingPageRenderer.java	(revision 15210)
@@ -49,5 +49,5 @@
 	extends JPanel {
 	
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	// gui components
@@ -135,14 +135,14 @@
 		titleLayout.setRows(2);
 		titleLayout.setVgap(2);
-		//titlePanel.setMinimumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_PANEL_HEIGHT));
-		//titlePanel.setMaximumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_PANEL_HEIGHT));
-		//titlePanel.setPreferredSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_PANEL_HEIGHT));
+		titlePanel.setMinimumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_PANEL_HEIGHT));
+		titlePanel.setMaximumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_PANEL_HEIGHT));
+		titlePanel.setPreferredSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_PANEL_HEIGHT));
 
 		titleLabel.setText(page.getDisplayText());
 		titleLabel.setFont(titleFont);
 		setImage(page.getImageResource());
-		//imagePanel.setMinimumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_IMAGE_HEIGHT));
-		//imagePanel.setMaximumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_IMAGE_HEIGHT));
-		//imagePanel.setPreferredSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_IMAGE_HEIGHT));
+		imagePanel.setMinimumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_IMAGE_HEIGHT));
+		imagePanel.setMaximumSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_IMAGE_HEIGHT));
+		imagePanel.setPreferredSize(new Dimension(SizeConstants.PAGE_WIDTH, SizeConstants.TITLE_IMAGE_HEIGHT));
 
 		// Ctrl Panel
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ValidatedTextInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ValidatedTextInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/ValidatedTextInputRenderer.java	(revision 15210)
@@ -33,5 +33,5 @@
 public class ValidatedTextInputRenderer extends SwingOutputFieldRenderer {
 
-    private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+    private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
     protected ValidatedTextInput inputField;
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/text/ConfirmPasswordTextInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/text/ConfirmPasswordTextInputRenderer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/text/ConfirmPasswordTextInputRenderer.java	(revision 15210)
@@ -5,5 +5,5 @@
 public class ConfirmPasswordTextInputRenderer extends PasswordTextInputRenderer {
 	
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 	
 	protected String getErrorMessage(){
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/ExecInstall.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/ExecInstall.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/ExecInstall.java	(revision 15210)
@@ -49,5 +49,5 @@
 public class ExecInstall {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 	public static final String CONFIG_RESOURCE = "/org/tp23/antinstaller/runtime/exe/script.fconfig";
 	
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/SwingRunner.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/SwingRunner.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/SwingRunner.java	(revision 15210)
@@ -54,5 +54,5 @@
 public class SwingRunner extends AntRunner implements Runner, PageCompletionListener {
 
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/TextRunner.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/TextRunner.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/TextRunner.java	(revision 15210)
@@ -47,5 +47,5 @@
 	implements Runner {
 	
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	protected final InstallerContext ctx;
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/AntLauncherFilter.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/AntLauncherFilter.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/AntLauncherFilter.java	(revision 15210)
@@ -38,5 +38,5 @@
 public class AntLauncherFilter implements ExecuteFilter {
 
-	private static final ResourceBundleHelper resHelper = new ResourceBundleHelper("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundleHelper resHelper = new ResourceBundleHelper("resources.LanguagePack");
 
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/LoadConfigFilter.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/LoadConfigFilter.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/LoadConfigFilter.java	(revision 15210)
@@ -279,4 +279,5 @@
 	 */
 	private OutputField getOutputFieldType(String type, Element field) throws ConfigurationException {
+
 		if (type.equalsIgnoreCase("text")) {
 			return new UnvalidatedTextInput();
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/PropertyLoaderFilter.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/PropertyLoaderFilter.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/runtime/exe/PropertyLoaderFilter.java	(revision 15210)
@@ -60,5 +60,5 @@
 public class PropertyLoaderFilter implements ExecuteFilter {
 	
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 	
 	public static final String LOAD = "true";
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/selfextract/ProgressIndicator.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/selfextract/ProgressIndicator.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/selfextract/ProgressIndicator.java	(revision 15210)
@@ -52,5 +52,5 @@
 
 	public static final String IMAGE_RESOURCE = "/resources/extract-image.png";
-	private static final ResourceBundle res = ResourceBundle.getBundle("org.tp23.antinstaller.renderer.Res");
+	private static final ResourceBundle res = ResourceBundle.getBundle("resources.LanguagePack");
 
 	private JPanel jPanel1 = new JPanel();
Index: /release-kits/shared/ant-installer/src_ext/org/tp23/antinstaller/taskdefs/Installer.java
===================================================================
--- /release-kits/shared/ant-installer/src_ext/org/tp23/antinstaller/taskdefs/Installer.java	(revision 15209)
+++ /release-kits/shared/ant-installer/src_ext/org/tp23/antinstaller/taskdefs/Installer.java	(revision 15210)
@@ -335,4 +335,5 @@
 		}
 		catch (Exception ex) {
+			log("validation failed");
 			ex.printStackTrace();
 			err();