Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/TargetInput.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/TargetInput.java	(revision 15310)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/input/TargetInput.java	(revision 15311)
@@ -62,4 +62,5 @@
 	//targets are ordered
 	private int idx;
+	private String diskRequirement;
 
 	private static int globalIdx = 1;
@@ -90,4 +91,8 @@
 	}
 
+	public void setDiskRequirement(String diskRequirement) {
+		this.diskRequirement = diskRequirement;
+	}
+
 	public String getForce() {
 		return force;
@@ -98,5 +103,4 @@
 	}
 
-
 	public String getStrict() {
 		return strict;
@@ -113,4 +117,8 @@
 	public void setOsSpecific(String osSpecific) {
 		this.osSpecific = osSpecific;
+	}
+
+	public String getDiskRequirement() {
+		return diskRequirement;
 	}
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/page/SimpleInputPage.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/page/SimpleInputPage.java	(revision 15310)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/page/SimpleInputPage.java	(revision 15311)
@@ -25,5 +25,5 @@
 
 	private String ifTarget;
-    private String ifProperty;
+	private String ifProperty;
 	private boolean overflow;
 
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/AIShortLabel.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/AIShortLabel.java	(revision 15311)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/AIShortLabel.java	(revision 15311)
@@ -0,0 +1,65 @@
+/* 
+ * Copyright 2005 Paul Hinds
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ * http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package org.tp23.antinstaller.renderer.swing;
+
+import java.awt.Dimension;
+
+import javax.swing.Icon;
+import javax.swing.JLabel;
+
+
+/**
+ * A JLabel with altered prefered size to facilitate fixing the width
+ * but still using a GridBagLayout
+ * @author Paul Hinds
+ * @version $Id: AILabel.java,v 1.2 2006/12/09 15:26:09 teknopaul Exp $
+ */
+public class AIShortLabel extends JLabel {
+
+	public AIShortLabel() {
+		super();
+	}
+	public AIShortLabel(String text) {
+		super(text);
+	}
+	public AIShortLabel(String text, int horizontalAlignment) {
+		super(text, horizontalAlignment);
+	}
+	public AIShortLabel(Icon image) {
+		super(image);
+	}
+	public AIShortLabel(Icon image, int horizontalAlignment) {
+		super(image, horizontalAlignment);
+	}
+	public AIShortLabel(String text, Icon icon, int horizontalAlignment) {
+		super(text, icon, horizontalAlignment);
+	}
+	private Dimension prefSize= new Dimension(60,
+			SizeConstants.FIELD_HEIGHT);
+	public Dimension getMinimumSize() {
+		return prefSize;
+	}
+	public Dimension getPreferredSize() {
+		return prefSize;
+	}
+	public void setOverflow(Dimension prefSize) {
+		this.prefSize = prefSize;
+	}
+	public Dimension getMaximumSize() {
+		return prefSize;
+	}
+	
+}
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/TargetInputRenderer.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/TargetInputRenderer.java	(revision 15310)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/renderer/swing/TargetInputRenderer.java	(revision 15311)
@@ -38,5 +38,7 @@
 
 	protected AILabel fieldLabel = new AILabel();
+	protected AIShortLabel sizeLabel = new AIShortLabel();
 	protected JCheckBox targetCheckBox = new JCheckBox();
+
 
 	public TargetInputRenderer() {
@@ -80,4 +82,6 @@
     private void jbInit() throws Exception {
 		fieldLabel.setText(outputField.getDisplayText());
+		sizeLabel.setText(outputField.getDiskRequirement());
+		sizeLabel.setMinimumSize( new Dimension( 80, 0 ) );
 		targetCheckBox.setSelected(InputField.isTrue(outputField.getDefaultValue()));
 		if(InputField.isTrue(outputField.getForce())){
@@ -94,27 +98,17 @@
 	public int addSelf(JPanel content,GBCF cf,  int row,boolean overflow) {
 
-		JLabel h = new JLabel("help");
-		h.setToolTipText(outputField.getExplanatoryText());
 
-		JPanel p, pp;
+		JLabel hlp = new JLabel("help");
+		hlp.setToolTipText(outputField.getExplanatoryText());
 
-		pp = new JPanel(new FlowLayout(FlowLayout.LEFT));
-		pp.add( targetCheckBox );
-		pp.add( h );
+		JPanel p;
 
-		p = new JPanel(new BorderLayout());
-		p.add( fieldLabel, BorderLayout.WEST );
-		p.add( pp, BorderLayout.CENTER );
+		p = new JPanel(new FlowLayout(FlowLayout.LEFT));
+		p.add( fieldLabel );
+		p.add( sizeLabel );
+		p.add( targetCheckBox );
+		p.add( hlp );
 		content.add(p);
 
-		p = new JPanel();
-		p.setMinimumSize( new Dimension(0,1) );
-		content.add(p);
-
-
-		
-		//if(overflow){
-		//	targetCheckBox.setOverflow(SizeConstants.OVERFLOW_FIELD_SIZE);
-		//}
 		return ++row;
 	}
Index: /release-kits/shared/ant-installer/src/org/tp23/antinstaller/selfextract/SelfExtractor.java
===================================================================
--- /release-kits/shared/ant-installer/src/org/tp23/antinstaller/selfextract/SelfExtractor.java	(revision 15310)
+++ /release-kits/shared/ant-installer/src/org/tp23/antinstaller/selfextract/SelfExtractor.java	(revision 15311)
@@ -125,8 +125,7 @@
 		File curDir = new File("t.tmp").getParentFile();
 		extractDir = new File(curDir, "antinstall");
-		int idx = 0;
-		while (extractDir.exists()) {
-			extractDir = new File(curDir, "antinstall" + (idx++));
-    }
+		for ( int i=0; extractDir.exists(); i++) {
+			extractDir = new File(curDir, "antinstall" + i);
+		}
 		extractDir.mkdirs();
 		extractDir.deleteOnExit();