Index: her-projects/trunk/gs3-webservices-democlient/build-forAnt1-6-5.xml
===================================================================
--- /other-projects/trunk/gs3-webservices-democlient/build-forAnt1-6-5.xml	(revision 15317)
+++ 	(revision )
@@ -1,201 +1,0 @@
-<?xml version="1.0"?>
-<!-- ====================================================================== 
-     April 2008 - GS3 web services democlient compile script
-     With lots of help from kjdon's Greenstone3 build and install script
-     See http://ant.apache.org/manual/ 
-     http://ant.apache.org/manual/usinglist.html
-     for info on build.xml ant files,                                                         
-     and http://ant.apache.org/manual/coretasklist.html
-     http://ant.apache.org/manual/tasksoverview.html
-====================================================================== -->
-<project name="gs3democlient" default="usage" basedir=".">
-<description>This buildfile is used to build the demo-client for Greenstone3's web services.</description>
-
-  <!-- ============ predefining properties for reuse =================== -->
- <property name="src.dir" value="${basedir}/src" />
- <property name="democlient.rootdir" value="${src.dir}/GS3DemoClient" />
- <property name="fedorags3.rootdir" value="${src.dir}/GS3Fedora" />
- <property name="democlient.src" value="${democlient.rootdir}/org" />
- <property name="fedorags3.src" value="${fedorags3.rootdir}/org" />
- <property name="build" value="${basedir}/build" />
- <property name="dist" value="${basedir}/dist" />
- <property name="QBRdata.rel.path" value="org/greenstone/gs3client/data" />
- <property name="dlservices.rel.path" value="org/greenstone/gs3client/dlservices" />
- <property name="gui.rel.path" value="org/greenstone/gs3client" />
- <property name="gs3services.rel.path" value="org/greenstone/gs3services" />
- <property name="exec.jar.name" value="GS3democlient.jar" /> <!-- name of the executable-->
- <property name="download.zip.name" value="gs3_webservices_democlient" />
- <property name="log4j.propFile" value="log4j.properties" />
- <property name="zip.excludes" value="dist/**,logs/**,gs3democlient.properties" />
-
-  <!-- ============ project classpath: everything in the lib folder =================== -->
- <path id="project.classpath">
-     <fileset dir="lib">
-      <include name="**/*.jar"/>
-    </fileset>
-  </path>
-
-<target name="usage" description="Prints out ant commands for the GS3 demo-client">
-	<echo>Type:</echo>
-	<echo>- ant build-demo-client</echo>
-	<echo>	for (compiling) and creating the demo-client executable</echo>
-	<echo>- ant compile-demo-client</echo>
-	<echo>	for compiling the democlient</echo>
-	<echo>- ant fedoraGS3jar</echo>
-	<echo>	for generating the fedoraGS3.jar dependency file</echo>
-	<echo>- ant QBRdatajar</echo>
-	<echo>	for generating the QBRdata.jar dependency file</echo>
-	<echo>- ant make-dist</echo>
-	<echo>	for generating the zip/gzip/bzip file of the project</echo>
-	<echo>- ant clean-democlient</echo>
-	<echo>	for deleting the *.class files from the GS3democlient's source</echo>
-	<echo>- ant clean</echo>
-	<echo>	for deleting the *.class files from the GS3democlient and GS3Fedora sources</echo>
-	<echo>- ant dist-clean</echo>
-	<echo>	for deleting the *.class files from the sources, the QBRdata.jar, fedoraGS3.jar, executable jar file, and any zips of the project folder</echo>	
-</target>
-
-
-<!-- Main targets: to build the GS3 web services demo-client and to create the tar.gz file for downloading -->
-<target name="build-demo-client" description="Creates the jar distribution file" depends="compile-demo-client">
-  <mkdir dir="${basedir}/logs" /> <!-- Need a logs dir for outputting log4j stuff-->
-  <delete file="${exec.jar.name}" /> <!--For now: Let's delete it first and do a fresh rebuild-->
-  <jar destfile="${exec.jar.name}"
-     basedir="${democlient.rootdir}/"
-     manifest="Manifest.MF"
-     excludes="${QBRdata.rel.path}/*.class"
-  />
-  <copy file="${src.dir}/${log4j.propFile}" tofile="${basedir}/${log4j.propFile}"/>
-<!-- LATER: only for tarring include source files, so that we can exclude the java files in this build?-->
-</target>
-
-<target name="make-dist" description="Generates the zip file of the lib and src folders and the executable ${exec.jar.name} file" depends="get-zipformat,ensure-exec-jar" if="zip.type">
-     <mkdir dir="${dist}" />
-     <antcall target="create-${zip.type}"/>
-</target>
-
-<!-- Compilation first ensures the existence of QBRdata.jar AND fedoraGS3.jar by checking whether these jars exist and if not, generating them. Then actual compilation of the GS3democlient starts. By now the QBRdata classes of the GS3democlient src folder would have been compiled, but that does not matter as javac only compiles when class files that are outdated or when they have not been generated yet.-->
-<target name="compile-demo-client" description="Compiles the GS3 demo-client" depends="ensure-QBRdata-jar,ensure-fedoraGS3-jar">
-    <javac srcdir="${democlient.rootdir}">
-      <classpath refid="project.classpath"/>
-      <exclude name="${gs3services.rel.path}/**" /> <!--gs3services package needs official gsdl.jar to compile, so we skip it as it is not part of the client anyway-->
-    </javac>
-</target>
-
-<!-- Cleaning targets -->
-<target name="clean-democlient" description="Removes all class files from the GS3demo-client">
-   <delete>
-    <fileset dir="${democlient.src}" includes="**/*.class"/>
-   </delete>
-</target>
-
-<target name="clean" description="Removes all class files from the GS3DemoClient and GS3Fedora source folders" depends="clean-democlient">
-   <delete>
-    <fileset dir="${fedorags3.src}" includes="**/*.class"/>
-   </delete>
-</target>
-
-<target name="dist-clean" description="Removes the project-specific jars fedoraGS3.jar, QBRdata.jar, ${exec.jar.name} files AND all class files from the GS3DemoClient and GS3Fedora source folders" depends="clean">
-   <delete includeEmptyDirs="true" failonerror="false">
-    <fileset file="${basedir}/lib/fedoraGS3.jar"/>
-    <fileset file="${basedir}/lib/QBRdata.jar"/>
-    <fileset file="${basedir}/${exec.jar.name}"/>
-    <fileset file="${basedir}/gs3democlient.properties"/>
-    <fileset dir="logs"/>
-    <fileset file="${log4j.propFile}"/>
-    <fileset file="${dist}/${download.zip.name}.tar"/>
-    <fileset file="${dist}/${download.zip.name}.tar.gz"/>
-    <fileset file="${dist}/${download.zip.name}.zip"/>
-    <fileset file="${dist}/${download.zip.name}.tar.bz2"/>
-   </delete>
-</target>
-
-<!-- Targets to generate the project-specific jar files QBRdata.jar and fedoraGS3.jar -->
-<target name="QBRdatajar" description="Compiles and creates the QBRdata.jar file needed by GS3demo-client">
-   <javac srcdir="${democlient.rootdir}/${QBRdata.rel.path}">
-      <classpath refid="project.classpath"/>
-    </javac>
-  <delete file="lib/QBRdata.jar" /> <!--For now: Let's delete it first and do a fresh rebuild-->
-  <jar destfile="lib/QBRdata.jar"
-     basedir="${democlient.rootdir}/"
-     excludes="${gui.rel.path}/*.*,${dlservices.rel.path}/**,${gs3services.rel.path}/**">
-  </jar>
-</target>
-
-<target name="fedoraGS3jar" description="Compiles and creates the fedoraGS3.jar file needed by GS3demo-client">
-   <javac srcdir="${fedorags3.rootdir}">
-      <classpath refid="project.classpath"/>
-    </javac>
-  <delete file="lib/fedoraGS3.jar" /> <!--For now: Let's delete it first and do a fresh rebuild-->
-  <jar destfile="lib/fedoraGS3.jar"
-     basedir="${fedorags3.rootdir}/"/>
-</target>
-
-<target name="update-gs3forclient.jar" description="Will update the class files in ${basedir}/lib/gs3_for_client.jar using svn to the latest versions of those files in Greenstone3's svn repository">
-</target>
-
-<!-- Targets that check for and ensure the existence of project-specific jar files -->
-<target name="check-QBRdata-jar" description="Checks for existence of dependency file QBRdata.jar">
-    <condition property="QBRdata.exists">
-	<available file="${basedir}/lib/QBRdata.jar"/>
-    </condition>
-</target>
-
-<target name="ensure-QBRdata-jar" description="Will generate QBRdata.jar if it did not exist" depends="check-QBRdata-jar" unless="QBRdata.exists">
-    <antcall target="QBRdatajar"/>
-</target>
-
-<target name="check-fedoraGS3-jar" description="Checks for existence of dependency file fedoraGS3.jar">
-    <condition property="fedoraGS3.exists">
-	<available file="${basedir}/lib/fedoraGS3.jar"/>
-    </condition>
-</target>
-
-<target name="ensure-fedoraGS3-jar" description="Will generate fedoraGS3.jar if it did not exist" depends="check-fedoraGS3-jar" unless="fedoraGS3.exists">
-    <antcall target="fedoraGS3jar"/>
-</target>
-
-<!-- generates the project's executable -->
-<target name="check-exec-jar" description="Checks for existence of executable file ${exec.jar.name}">
-    <condition property="executable.exists">
-	<available file="${basedir}/${exec.jar.name}"/>
-    </condition>
-</target>
-
-<target name="ensure-exec-jar" description="Will generate ${exec.jar.name} if it did not exist" depends="check-exec-jar" unless="executable.exists">
-    <antcall target="build-demo-client"/>
-</target>
-
-<!-- User input for generating compressed output file for one of the chosen file types. A choice of zip, tar.gz (tar gzip), or tar.bz2 (tar bzip)-->
-<target name="create-targzip" if="zip.type" description="User chose to create a tar.gz file of the project">
-    <tar destfile="${dist}/${download.zip.name}.tar.gz" basedir="${basedir}" compression="gzip" excludes="${zip.excludes}" longfile="gnu" /> 
-    <echo>If the filepaths are longer than 100 characters, GNU compatible tar commands are necessary to untar the tar.gz</echo>
-</target>
-
-<target name="create-tarbzip" if="zip.type" description="User chose to create a tar.bz2 file of the project">
-    <tar destfile="${dist}/${download.zip.name}.tar.bz2" basedir="${basedir}" compression="bzip2" excludes="${zip.excludes}" longfile="gnu" /> 
-    <echo>If the filepaths are longer than 100 characters, GNU compatible tar commands are necessary to untar the tar.gz</echo>
-</target>
-
-<target name="create-zip" if="zip.type" description="User chose to create a zip file of the project">
-     <zip basedir="${basedir}" destfile="${dist}/${download.zip.name}.zip" 
-	excludes="${zip.excludes}" />
-</target>
-
-<target name="get-zipformat"> 
-<!--<input addproperty="zip.type" validargs="zip,gzip,bzip">--><!-- doesn't work with default value-->
-    <input addproperty="zip.format" defaultvalue="zip">What type of compressed output file do you want to generate?
-Type one of: zip, tar.gz, tar.bz2
-Press enter for default: zip /></input>
-    <condition property="zip.type" value="targzip"> 
-      <equals arg1="tar.gz" arg2="${zip.format}"/>
-    </condition>
-    <condition property="zip.type" value="zip"> 
-      <equals arg1="zip" arg2="${zip.format}"/>
-    </condition>
-    <condition property="zip.type" value="tarbzip">
-      <equals arg1="tar.bz2" arg2="${zip.format}"/>
-    </condition>
-    <echo>You chose output file type: ${zip.type}</echo>
-  </target>
-</project>